Coin: SbSphereSheetProjector Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

SbSphereSheetProjector Class Reference
Projector Classes

The SbSphereSheetProjector class projects 2D points to 3D points on a sheet covering a spherical shape. More...

`#include <Inventor/projectors/SbSphereSheetProjector.h>`

Inheritance diagram for SbSphereSheetProjector:

## Public Member Functions
| SbSphereSheetProjector (const SbBool orienttoeye=TRUE)
| SbSphereSheetProjector (const SbSphere &sph, const SbBool orienttoeye=TRUE)
virtual SbProjector * | copy (void) const
virtual SbVec3f | project (const SbVec2f &point)
virtual SbRotation | getRotation (const SbVec3f &point1, const SbVec3f &point2)
Public Member Functions inherited from SbSphereProjector
SbVec3f | projectAndGetRotation (const SbVec2f &point, SbRotation &rot)
void | setSphere (const SbSphere &sph)
const SbSphere & | getSphere (void) const
void | setOrientToEye (const SbBool orienttoeye)
SbBool | isOrientToEye (void) const
void | setFront (const SbBool infront)
SbBool | isFront (void) const
SbBool | isPointInFront (const SbVec3f &point) const
virtual void | setWorkingSpace (const SbMatrix &space)
Public Member Functions inherited from SbProjector
virtual void | setViewVolume (const SbViewVolume &vol)
const SbViewVolume & | getViewVolume (void) const
const SbMatrix & | getWorkingSpace (void) const
virtual SbBool | tryProject (const SbVec2f &point, const float epsilon, SbVec3f &result)

## Protected Member Functions
void | setupPlane (void)
Protected Member Functions inherited from SbSphereProjector
| SbSphereProjector (const SbBool orienttoeye)
| SbSphereProjector (const SbSphere &s, const SbBool orienttoeye)
SbBool | intersectSphereFront (const SbLine &l, SbVec3f &result)
Protected Member Functions inherited from SbProjector
| SbProjector (void)
virtual | ~SbProjector ()
SbLine | getWorkingLine (const SbVec2f &point) const
float | findVanishingDistance (void) const
SbBool | verifyProjection (const SbVec3f &projpt) const

## Protected Attributes
SbVec3f | workingProjPoint
SbVec3f | planePoint
SbVec3f | planeDir
float | planeDist
SbPlane | tolPlane
Protected Attributes inherited from SbSphereProjector
SbBool | intersectFront
SbSphere | sphere
SbBool | orientToEye
SbBool | needSetup
SbVec3f | lastPoint
Protected Attributes inherited from SbProjector
SbViewVolume | viewVol
SbMatrix | worldToWorking
SbMatrix | workingToWorld

## Detailed Description

The SbSphereSheetProjector class projects 2D points to 3D points on a sheet covering a spherical shape.

The following standalone example shows how screen space coordinates projects into 3D when mapped with an SbSphereSheetProjector. It outputs the resulting projections as an SoPointSet in a Inventor-file on stdout:

#include <cstdio>
#include <Inventor/SbLinear.h>
#include <Inventor/projectors/SbSphereSheetProjector.h>
#include <Inventor/SoDB.h>
int
main(void)
{
SoDB::init();
const float START = 0.0f;
const float END = 1.0f;
const float STEPS = 50.0f;
const float STEPSIZE = ((END - START) / STEPS);
SbSphere s(SbVec3f(0, 0, 0), 0.8);
SbSphereSheetProjector ssp(s, TRUE); // last argument is orientToEye
SbViewVolume volume;
volume.ortho(-1, 1, -1, 1, -1, 1);
ssp.setViewVolume(volume);
(void)fprintf(stdout, "#Inventor V2.1 ascii\n\n"
"Separator {\n"
" Coordinate3 {\n"
" point [\n");
for (float i=START; i <= END; i += STEPSIZE) {
for (float j=START; j <= END; j += STEPSIZE) {
SbVec3f v = ssp.project(SbVec2f(j, i));
(void)fprintf(stdout, "\t%f %f %f,\n", v[0], v[1], v[2]);
}
}
(void)fprintf(stdout, " ]\n"
" }\n"
" DrawStyle { pointSize 2 }\n"
" PointSet { }\n"
"}\n");
return 0;
}
SbSphereSheetProjector::SbSphereSheetProjector
SbSphereSheetProjector(const SbBool orienttoeye=TRUE)
Definition SbSphereSheetProjector.cpp:139
SbSphere
The SbSphere class is a representation of a sphere.
Definition SbSphere.h:42
SbVec2f
The SbVec2f class is a 2 dimensional vector with floating point coordinates.
Definition SbVec2f.h:49
SbVec3f
The SbVec3f class is a 3 dimensional vector with floating point coordinates.
Definition SbVec3f.h:51
SbViewVolume
The SbViewVolume class is a viewing volume in 3D space.
Definition SbViewVolume.h:50
SbViewVolume::ortho
void ortho(float left, float right, float bottom, float top, float nearval, float farval)
Definition SbViewVolume.cpp:443
SoDB::init
static void init(void)
Definition SoDB.cpp:200

The projections to 3D points in the resulting Inventor-file looks like this:

Rendering of Example Resulting Projections

## Constructor & Destructor Documentation

## ◆ SbSphereSheetProjector() [1/2]

SbSphereSheetProjector::SbSphereSheetProjector | ( | const SbBool | orienttoeye = TRUE | ) |

Constructor. Uses default sphere definition, see SbSphereProjector::SbSphereProjector().

orienttoeye decides whether or not the sheet should always be oriented towards the viewer.

## ◆ SbSphereSheetProjector() [2/2]

SbSphereSheetProjector::SbSphereSheetProjector | ( | const SbSphere & | sph,
|  | const SbBool | orienttoeye = TRUE )

Constructor with explicit definition of projection sphere.

## Member Function Documentation

## ◆ copy()

SbProjector * SbSphereSheetProjector::copy | ( | void |  | ) | const
| virtual

Construct and return a copy of this projector. The caller is responsible for destructing the new instance.

Note that if the Coin library has been built as a DLL under Microsoft Windows and you use this method from application code, you must make sure that both the Coin DLL and the application executable are using the same instance of a C Run-Time (CRT) library. Otherwise, you will get memory heap corruption upon deallocating the returned instances, eventually leading to mysterious crashes.

Implements SbProjector.

## ◆ project()

SbVec3f SbSphereSheetProjector::project | ( | const SbVec2f & | point | ) |
| virtual

Project the 2D point from normalized viewport coordinates to a 3D point. The mapping will be done in accordance with the type of the projector.

Implements SbProjector.

## ◆ getRotation()

SbRotation SbSphereSheetProjector::getRotation | ( | const SbVec3f & | point1,
|  | const SbVec3f & | point2 )
| virtual

Returns rotation on the projection surface which reorients point1 to point2.

Implements SbSphereProjector.

## ◆ setupPlane()

void SbSphereSheetProjector::setupPlane | ( | void |  | ) |
| protected

Recalculates projection surface settings after changes to the parameters.

## Member Data Documentation

## ◆ workingProjPoint

SbVec3f SbSphereSheetProjector::workingProjPoint
| protected

Last projected point, in the working space coordinate system.

## ◆ planePoint

SbVec3f SbSphereSheetProjector::planePoint
| protected

Position of the center of the sphere in the plane of the hyberbolic sheet.

## ◆ planeDir

SbVec3f SbSphereSheetProjector::planeDir
| protected

Normal vector of the plane defining the orientation of the sheet.

## ◆ planeDist

float SbSphereSheetProjector::planeDist
| protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ tolPlane

SbPlane SbSphereSheetProjector::tolPlane
| protected

The tolerance value specifying how much of the sphere is "above" the sheet.

The documentation for this class was generated from the following files:

- SbSphereSheetProjector.h
- SbSphereSheetProjector.cpp